SystemOrganization addCategory: #'DBZ tp'!

Object subclass: #Bueno
	instanceVariableNames: 'guerrerosBuenos bueno revivirAliado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Bueno methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:45'!
agregar: unGuerrero
guerrerosBuenos add: unGuerrero! !

!Bueno methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 18:54'!
bando
^'bueno'! !

!Bueno methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla
	^ self coleccionSemillasHermitanio size > 0! !

!Bueno methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla: unGuerrero 
	^ self coleccionSemillasHermitanio size > 1
		& (self aliados includes: unGuerrero) ! !

!Bueno methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla: unGuerrero A: otroGuerrero 
	^ unGuerrero coleccionSemillasHermitanio size > 0
		& (unGuerrero aliados includes: otroGuerrero)! !

!Bueno methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:39'!
guerreros
^guerrerosBuenos! !

!Bueno methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:40'!
initialize
guerrerosBuenos:= Bag new.! !

!Bueno methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 19:43'!
pedirDeseo
^revivirAliado! !

!Bueno methodsFor: 'as yet unclassified' stamp: ''!
tieneSentidoPedirDeseoPor: guerrero 
	^ guerrero aliados
		anySatisfy: [:unAliado | unAliado seMurio]! !

Object subclass: #ErrorPoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #ErrorSemilla
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #Esfera
	instanceVariableNames: 'cantidadEstrellas mundo error errorEsfera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Esfera methodsFor: 'as yet unclassified' stamp: ''!
cantidadEstrellas
	^ cantidadEstrellas! !

!Esfera methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 11:43'!
cantidadEstrellas: unaCantidad 
((unaCantidad <=7)&(self cantidadEstrellas = nil)) ifTrue: [cantidadEstrellas := unaCantidad] ifFalse: [ 'error' ]! !

!Esfera methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 10:51'!
mundo
^mundo! !

!Esfera methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 11:22'!
mundo: unMundo 
mundo:= unMundo.
(self mundo) esferas add: self.! !

Object subclass: #Guerrero
	instanceVariableNames: 'energia puntosVida nivelPelea coleccionSemillasHermitanio aliados bandoContrario puntosVidaPerdidos puntosAtaqueRecibidos puntosAtaquesRecibidos llevaPuesto recibeAtaque unTraje poderesConocidos cantidadAtaquesRecibidos ataquesRecibidos ataque unAtaque poder poderMaximo vidaPerdida coleccionEsferas aliado esfera mundo ultimosAtacados utimoAtacado unaEsfera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
agregarEsferaColeccion: unaEsfera 
	coleccionEsferas add: unaEsfera! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
agregarSemillaColeccion: unaSemilla 
	coleccionSemillasHermitanio add: unaSemilla! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 18:17'!
algunaEsfera
^self coleccionEsferas anyOne! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:42'!
aliadoMasPoderoso
( self aliados )do: [ : unAliado| unAliado nivelPelea ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:44'!
aliadoMuertoMasPoderoso
( self aliadosMuertos )do: [ : unAliado| unAliado nivelPelea ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados
	^ aliados! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados: unaBag 
	aliados := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliadosMuertos
	^ aliados
		select: [:unGuerrero | unGuerrero seMurio]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliadosVivos
	^ aliados
		reject: [:aliado | aliado seMurio] ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:31'!
aliarCon: unGuerrero 
	^((self puedeAliarse: unGuerrero)
			& (unGuerrero puedeAliarse: self))
		ifTrue: [aliados add: unGuerrero.
			unGuerrero aliados add: self] ifFalse: ['no se pueden aliar loco']! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aprende: unPoder 
	poderesConocidos add: unPoder! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 17:02'!
atacarCon: unPoder a: unGuerrero 
	^ (self puedeHacerPoder: unPoder)
		ifTrue: [unGuerrero recibe: unPoder.self ultimosAtacados add: unGuerrero. unGuerrero estaMoribundo ifTrue: [self sacarleEsferasA: unGuerrero]. self recibeAutoDao: unPoder. (self estaMoribundo) ifTrue:[(self unAliadoVivo) sacarleEsferasA:self]]
		ifFalse: [ErrorPoder new signal
			"no se puede guachin"] ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
atacarCon: unPoder menorQue: unosPuntosAtaque 
	^ self! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
atacarConMaximoPoderA: unGuerrero 
	poderMaximo := poderesConocidos
				detectMax: [:unPoder | unPoder puntosAtaque: self].
	self atacarCon: poderMaximo a: unGuerrero! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos
	^ ataquesRecibidos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos: unaBag 
	ataquesRecibidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 11:02'!
bandoContrario
^self bando= Bueno ifTrue: [ Malo ] ifFalse: [ Bueno ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
calculoAtaquesRecibidos
	^ self ataquesRecibidos size // 3 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 19:24'!
candidatosAEsferas
|enemigosCandidatos|
enemigosCandidatos:= Bag new.
^(self aliadosVivos > self cantidadEsferas ) ifTrue: [ self aliadosVivos] ifFalse: [ (enemigosCandidatos size <7-(self aliadosVivos)&(self ultimoAtacado ~= nil)) whileTrue:[enemigosCandidatos add: ( self ultimosAtacados remove: self ultimoAtacado)]&((self aliadosVivos) union: (enemigosCandidatos)) ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadAtaquesRecibidos: unaCant 
	cantidadAtaquesRecibidos := unaCant! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 11:52'!
cantidadEsferas
^self coleccionEsferas size! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 11:57'!
cantidadEsferasAliados
^self aliados sum: [ : unAliado| unAliado cantidadEsferas ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadSemillasHermitanio
	^ coleccionSemillasHermitanio size ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cedeLasEsferasA: unGuerrero 
	self AliadosVivos > 6
		ifTrue: [7
				timesRepeat: [self cederEsferaAAliado]]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cederEsferaAAliado
	aliado := aliados anyOne.
	esfera := coleccionEsferas anyOne.
	aliado agregarEsferaColeccion: esfera.
	coleccionEsferas remove: esfera! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionEsferas
	^ coleccionEsferas! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionEsferas: unaBag 
	coleccionEsferas := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionSemillasHermitanio
	^ coleccionSemillasHermitanio! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionSemillasHermitanio: unaBag 
	coleccionSemillasHermitanio := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
come: semillaHermitanio 
	(self puedeComer: semillaHermitanio)
		ifTrue: [self puntosVida: 1000.
			energia := self nivelPelea * 5 // 100 + self puntosExtra + self energia.
			coleccionSemillasHermitanio remove: semillaHermitanio]
		ifFalse: [ErrorSemilla new signal
			"no se puede guachin"]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 18:27'!
darEsferaA:unGuerrero
|laEsfera|
(self cantidadEsferas >0) ifTrue: [(laEsfera:= self algunaEsfera)&(self coleccionEsferas remove: laEsfera )].
unGuerrero coleccionEsferas add: laEsfera.! !

!Guerrero methodsFor: 'accessing' stamp: ''!
energia
	^ energia! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
energia: unaCantidad 
	energia := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:44'!
esAliado: unGuerrero
^self aliados includes: unGuerrero! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:17'!
esBueno
^(self bando) bando = 'bueno'! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 09:48'!
esFuerte
^nivelPelea >= 15000! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
estaMoribundo
	^ self puntosVida <= 50 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:50'!
incrementarPoder: porcentaje
nivelPelea:= nivelPelea * (porcentaje / 100)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 17:42'!
initialize
	coleccionSemillasHermitanio := Bag new.
	self energia: 200.
	self puntosVida: 1000.
	ataquesRecibidos := Bag new.
	poderesConocidos := Bag new.
	coleccionEsferas := Bag new.
	aliados:= Bag new.
	mundo:= Mundo new.
	ultimosAtacados:= OrderedCollection new.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 09:28'!
invocarShenLong
self puedeLlamarAShenLong ifTrue:[ (self bando) pedirDeseo ] ifFalse: [ 'no podes chabon' ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 13:22'!
juntaTodasLasEsferas
^((self cantidadEsferas) + (self cantidadEsferasAliados) )= (mundo esferas size)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto
	^ llevaPuesto! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto: unTraje 
	llevaPuesto := unTraje! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 11:54'!
mundo
^mundo! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 12:33'!
mundo: unMundo 
mundo:= unMundo.
unMundo guerreros add: self! !

!Guerrero methodsFor: 'accessing' stamp: 'TomsRambaud 10/27/2013 08:49'!
nivelPelea
^nivelPelea! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
nivelPelea: unNivel 
	nivelPelea := unNivel! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:50'!
noEsRepetido: guerrero
^(self esAliado:guerrero)not & (guerrero ~= self)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
pedir: unaSemilla A: unGuerrero 
	self cantidadSemillasHermitanio = 0
			& (self aliados includes: unGuerrero)
			& (unGuerrero bando cedeSemilla: unGuerrero A: self)
		ifTrue: [unGuerrero coleccionSemillasHermitanio remove: unaSemilla.
			self coleccionSemillasHermitanio add: unaSemilla]
		ifFalse: [Error new signal]! !

!Guerrero methodsFor: 'accessing' stamp: ''!
poderesConocidos
	^ poderesConocidos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
poderesConocidos: unaBag 
	poderesConocidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeAtacarA: unGuerrero 
	^ (aliados includes: unGuerrero) not ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeComer: unaSemilla 
	^ (coleccionSemillasHermitanio
		anySatisfy: [:semilla | semilla = unaSemilla])
		& (self energia < 200) ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerPoder: unPoder 
	^ (poderesConocidos
		anySatisfy: [:algunPoder | algunPoder = unPoder])
		& (unPoder puedeHacerlo: self)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 13:56'!
puedeLlamarAShenLong
	^ self juntaTodasLasEsferas & (self energia > 50) & self tieneSentidoQuePidaDeseo. ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeRealizarPoderes
	^ poderesConocidos
		select: [:unPoder | self puedeHacerPoder: unPoder] ! !

!Guerrero methodsFor: 'accessing' stamp: ''!
puntosVida
	^ puntosVida! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puntosVida: unaCantidad 
	puntosVida := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
recibe: algunPoder 
	ataquesRecibidos add: algunPoder.
	puntosVida := self puntosVida
				- (self vidaPerdidaPor: algunPoder)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 13:13'!
recibeAutoDao: unPoder
puntosVida:= (self puntosVida) - ( unPoder autoDao: self)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 19:33'!
repartirEsferas
self candidatosEsferas do: [ : unCandidato| self darEsferaA: unCandidato ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 19:41'!
revivir
puntosVida:= 1000.
! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:45'!
revivirAliado
self aliadoMuertoMasPoderoso revivir! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
sacarleEsferasA: enemigo 
	coleccionEsferas addAll: enemigo coleccionEsferas.
	enemigo seQuedaSinEsferas! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
seMurio
	^ self puntosVida <= 0 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
tieneEnergiaPara: unPoder 
	self energia > unPoder energiaNecesaria! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 13:25'!
tieneSentidoQuePidaDeseo
	^ (self bando tieneSentidoPedirDeseoPor: self ) ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 17:05'!
ultimoAtacado
^self ultimosAtacados last! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 16:57'!
ultimosAtacados
^ultimosAtacados! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 12:54'!
unAliadoVivo
^self aliadosVivos anyOne.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 19:26'!
unCandidatoEsferas
^self candidatosEsferas anyOne! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
vidaPerdidaPor: unPoder 
	^ (unPoder puntosAtaque: self)
		- (llevaPuesto pasaUnDaoDe: unPoder A: self)
		+ (self resistenciaDe: unPoder)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:59'!
volverseMasFuerte
self incrementarPoder: 50.
(self aliadosVivos) do: [ : unAliado| unAliado incrementarPoder: 10 ]! !

Guerrero subclass: #Monstruo
	instanceVariableNames: 'otroGuerrero puedeAliarse puntosPelea aliados bando'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Monstruo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:51'!
bando
	^ bando! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 12:03'!
initialize 
(super initialize).
(bando:= Malo new ).
(mundo guerreros add: self) ! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:51'!
puedeAliarse: unGuerrero 
	^ (self noEsRepetido: unGuerrero)! !

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
resistenciaDe: unPoder 
	^ 20 ! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: 'aliados bandoContrario puntosPelea oponentes bando gohan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados gohan'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados gohan'!

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
bando
	^ bando! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 12:02'!
bando: unBando 
	(bando:= unBando new).
	(mundo guerreros add: self)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:51'!
puedeAliarse: guerrero 
		^ (guerrero esBueno) ifTrue: [ ((mundo nivelBuenos ) <= (mundo nivelMalos))&(self noEsRepetido: guerrero)] ifFalse: [ ((mundo nivelMalos ) <= (mundo nivelBuenos))&(self noEsRepetido: guerrero)]! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ 100 * aliados size! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
resistenciaDe: unPoder 
	^ (unPoder puntosAtaque: self)
		* 0.1 + (self energia * 0.02) ! !

Guerrero subclass: #Terricola
	instanceVariableNames: 'otroGuerrero puedeAliarse s aliados bando'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:52'!
bando
	^ bando! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 12:21'!
initialize 
(super initialize).
(bando:= Bueno new).
(mundo guerreros add: self)! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:43'!
puedeAliarse: unGuerrero 
	^ ((unGuerrero esBueno) &
(unGuerrero esFuerte)&(unGuerrero ~= self) ) ifTrue:[true] ifFalse: [(aliados select: [:unPersonaje| unPersonaje] not esFuerte) size < 5]! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ self energia: self energia + 200! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
resistenciaDe: unPoder 
	^ (unPoder puntosAtaque: self)
		* 0.05! !

Object subclass: #Malo
	instanceVariableNames: 'guerrerosMalos malo volverseMasFuerte'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Malo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:45'!
agregar: unGuerrero
guerrerosMalos add: unGuerrero! !

!Malo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 18:54'!
bando
^'malo'! !

!Malo methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla
	^ self cantidadSemillasHermitanio > 1 ! !

!Malo methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla: unGuerrero 
	^ self coleccionSemillasHermitanio size > 1
		& (self aliados includes: unGuerrero) ! !

!Malo methodsFor: 'as yet unclassified' stamp: ''!
cedeSemilla: unGuerrero A: otroGuerrero 
	^ unGuerrero coleccionSemillasHermitanio size > 1
		& (unGuerrero aliados includes: otroGuerrero)! !

!Malo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:35'!
guerreros
^guerrerosMalos! !

!Malo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 10:38'!
initialize 
guerrerosMalos:= Bag new.! !

!Malo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/27/2013 08:52'!
pedirDeseo
^volverseMasFuerte! !

!Malo methodsFor: 'as yet unclassified' stamp: ''!
tieneSentidoPedirDeseoPor: guerrero 
	^ true ! !

Object subclass: #Mundo
	instanceVariableNames: 'guerrerosBuenos guerrerosMalos guerreros bueno malo esferas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 18:54'!
buenos
^self guerreros select: [ : unGuerrero| (unGuerrero bando) bando = 'bueno' ]! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 10:49'!
esferas
^esferas! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 12:15'!
guerreros
^guerreros! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/26/2013 10:49'!
initialize 
guerreros:= Bag new.
esferas:= Bag new.! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 18:54'!
malos
^self guerreros select: [ : unGuerrero| (unGuerrero bando) bando = 'malo']! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:13'!
nivelBuenos
^self buenos sum: [ : unGuerrero| unGuerrero nivelPelea ]! !

!Mundo methodsFor: 'as yet unclassified' stamp: 'TomsRambaud 10/24/2013 19:11'!
nivelMalos
^self malos sum: [ : unGuerrero| unGuerrero nivelPelea ]! !

Object subclass: #PoderColectivos
	instanceVariableNames: 'minimoAliadosVivos energiaColectivaMinima'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
autoDao: unGuerrero 
	^ 0 ! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
energiaColectivaMinima: unaCantidad 
	energiaColectivaMinima := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos
	^ minimoAliadosVivos! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos: unaCantidad 
	minimoAliadosVivos := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 200 & (self minimoAliadosVivos > 4) ! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ unGuerrero aliados size + energiaColectivaMinima + 200! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosAtaque unosAtaque potencia unAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
autoDao: unGuerrero 
	^ 0 ! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
energiaNecesaria
	^ 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
potencia
	^ potencia! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
potencia: unaPotencia 
	potencia := unaPotencia! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 50 ! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ self potencia! !

Object subclass: #PoderPotente
	instanceVariableNames: 'potenciaAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
autoDao: unGuerrero 
	^ 0 ! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo
	^ true ! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ unGuerrero nivelPelea / 500 * potenciaAtaque ! !

Object subclass: #PoderVengativo
	instanceVariableNames: 'energiaUtilizada minimosAliadosMuertos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
autoDao: unGuerrero 
	^ (self puntosAtaque: unGuerrero)
		/ 100 * 20 ! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
energiaUtilizada
	^ energiaUtilizada! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
minimosAliadosMuertos
	^ minimosAliadosMuertos! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia >= energiaUtilizada & (minimosAliadosMuertos <= unGuerrero aliadosMuertos) & (unGuerrero aliadosVivos > 0)! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ 250 * unGuerrero aliadosMuertos ! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: ''!
setearEnergiaUtilizada: valor 
	energiaUtilizada := valor! !

Object subclass: #SemillaHermitanio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!SemillaHermitanio methodsFor: 'as yet unclassified' stamp: ''!
esComidaPor: unGuerrero 
	(self puedeComerme: unGuerrero)
		ifFalse: [ErrorEnergia new signal
			"El guerrero no puede comer la semilla"].
	self restaura: unGuerrero! !

!SemillaHermitanio methodsFor: 'as yet unclassified' stamp: ''!
puedeComerme: unGuerrero 
	^ (unGuerrero coleccionSemillasHermitanio
		anySatisfy: [:semilla | semilla = self])
		& (unGuerrero energia < 200)! !

!SemillaHermitanio methodsFor: 'as yet unclassified' stamp: ''!
restaura: unGuerrero 
	^ self! !

Object subclass: #ShenLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #TrajeComun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeComun methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero daoPor: unPoder 
	^ (unPoder puntosAtaque: unGuerrero)
		* 0.1! !

!TrajeComun methodsFor: 'as yet unclassified' stamp: ''!
pasaUnDaoDe: unPoder A: unGuerrero 
	^ (unPoder puntosAtaque: self)
		- (unGuerrero llevaPuesto efecto: self daoPor: unPoder)! !

TrajeComun subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero daoPor: unPoder 
	^ (super efecto: unGuerrero daoPor: unPoder)
		- 20! !

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: ''!
pasaUnDaoDe: unPoder A: unGuerrero 
	^ super pasaUnDaoDe: unPoder A: unGuerrero! !

Object subclass: #TrajeEntrenamiento
	instanceVariableNames: 'calculoAtaquesRecibidos ataquesRecibidosA ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEntrenamiento methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero daoPor: unPoder 
	unGuerrero calculoAtaquesRecibidos > 0
		ifTrue: [unGuerrero nivelPelea: unGuerrero nivelPelea + (100 * unGuerrero calculoAtaquesRecibidos).
			unGuerrero energia: unGuerrero energia - 20]
		ifFalse: [unGuerrero energia: unGuerrero energia - 20]! !

!TrajeEntrenamiento methodsFor: 'as yet unclassified' stamp: ''!
pasaUnDaoDe: unPoder 
	^ (unPoder puntosAtaque: self)
		- (self llevaPuesto efecto: self daoPor: unPoder)! !

!TrajeEntrenamiento methodsFor: 'as yet unclassified' stamp: ''!
pasaUnDaoDe: unPoder A: unGuerrero 
	^ (unPoder puntosAtaque: self)
		- (self llevaPuesto efecto: self daoPor: unPoder)! !

Error subclass: #ErrorEnergia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!ErrorEnergia methodsFor: 'as yet unclassified' stamp: ''!
metodo: unGuerrero 
	unGuerrero energia > 200 ! !
